
// FOR ARDUINO FIO
// 3.3 V!!
// SDA: A4  SCL: A3


#include <Wire.h>

uint8_t _addr =    0x28;
uint8_t _i2caddr = 0x28;
uint8_t raw[4];
float humidity;
float temperatureC;


// the setup routine runs once when you press reset: "
void setup() {
  // initialize serial communication at 9600 bits per second:
  Serial.begin(9600);
  Wire.begin(_addr);
  
}

// the loop routine runs over and over again forever:
void loop() {
  
  
//  if (Wire.requestFrom(_addr, (uint8_t)1, (uint8_t)true)) {
//    Serial.println("present: true");
//  } else {
//    Serial.println("present: false");
//  }
  
    Wire.beginTransmission(_i2caddr);
    Wire.write(0xA0);
    Wire.write(0);
    Wire.write(0);
    Wire.endTransmission();
    delay(50);

  
    Wire.beginTransmission(_i2caddr);
    Wire.requestFrom((uint8_t)_i2caddr, (uint8_t)4, (uint8_t)true);
    raw[0] = Wire.read();
    raw[1] = Wire.read();
    raw[2] = Wire.read();
    raw[3] = Wire.read();	
    Wire.endTransmission();  
  
  
  Serial.print("raw[0]: ");  Serial.println(raw[0], HEX);
  Serial.print("raw[1]: ");  Serial.println(raw[1], HEX);
  Serial.print("raw[2]: ");  Serial.println(raw[2], HEX);
  Serial.print("raw[3]: ");  Serial.println(raw[3], HEX);  
  Serial.print("\n");
  
  humidity = (((raw[0] & 63) << 8) + raw[1]) / 163.84;
  temperatureC = (((raw[2] << 6) + (raw[3] / 4)) / 99.29) - 40; 
  
  Serial.print("Humidity: ");     Serial.println(humidity);
  Serial.print("Temperature: ");  Serial.println(temperatureC);  
  Serial.print("\n");  
  
  
  delay(2000);        // delay in between reads for stability "
}
